Bug 510533 - Review Request: ghc-editline - Haskell editline library
Review Request: ghc-editline - Haskell editline library
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Yaakov Nemoy
Fedora Extras Quality Assurance
:
Depends On:
Blocks: 511586
  Show dependency treegraph
 
Reported: 2009-07-09 12:59 EDT by Jochen Schmitt
Modified: 2009-07-22 20:39 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-07-22 20:38:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
loupgaroublond: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Jochen Schmitt 2009-07-09 12:59:06 EDT
Spec URL: http://www.herr-schmitt.de/pub/ghc-editline/ghc-editline.spec
SRPM URL: http://www.herr-schmitt.de/pub/ghc-editline/ghc-editline-0.2.1.0-1.fc11.src.rpm
Description: <description here>
This package contains binding to the BSD editline library
(http://thrysoee.dk/editline). It provides a basic interface
 to the editline API for reading lines in input for the user.

Additionally, a readline compatibility module is included which
provides a subset of the function of the readline library.
Comment 1 Yaakov Nemoy 2009-07-15 14:15:44 EDT
First off, the macro is %ix86 and not %Ix86. Macros aren't in German ;). Otherwise, a i586 package won't be built.

I've found further errors i'll highlight below, but i suggest checking your capitilization in the spec file.

MUST: rpmlint must be run on every package. The output should be posted in the review.[1]
ghc-editline.src: I: checking
ghc-editline.src: I: checking
ghc-editline-devel.ppc: I: checking
ghc-editline-devel.x86_64: I: checking
ghc-editline-doc.ppc: I: checking
ghc-editline-doc.ppc: W: non-standard-group development/Libraries
Check what possible groups are, these are RPM groups, btw.

ghc-editline-doc.ppc: W: percent-in-%post
ghc-editline-doc.ppc: W: one-line-command-in-%post %ghc_reindex_haddoc
ghc-editline-doc.ppc: W: percent-in-%postun
Check your spelling here, haddock is spelled with a k.

ghc-editline-doc.x86_64: I: checking
ghc-editline-doc.x86_64: W: non-standard-group development/Libraries
ghc-editline-doc.x86_64: W: percent-in-%post
ghc-editline-doc.x86_64: W: one-line-command-in-%post %ghc_reindex_haddoc
ghc-editline-doc.x86_64: W: percent-in-%postun
ghc-editline-prof.ppc: I: checking
ghc-editline-prof.ppc: E: devel-dependency ghc-editline-devel
ghc-editline-prof.ppc: W: no-documentation
ghc-editline-prof.ppc: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/editline-0.2.1.0/libHSeditline-0.2.1.0_p.a
ghc-editline-prof.x86_64: I: checking
ghc-editline-prof.x86_64: E: devel-dependency ghc-editline-devel
ghc-editline-prof.x86_64: W: no-documentation
ghc-editline-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.3/editline-0.2.1.0/libHSeditline-0.2.1.0_p.a
8 packages and 0 specfiles checked; 2 errors, 12 warnings.

--FAIL

MUST: The package must be named according to the Package Naming Guidelines .
--CHECK

MUST: The spec file name must match the base package %{name}, in the format %{name}.spec unless your package has an exemption. [2] .
--CHECK

MUST: The package must meet the Packaging Guidelines .
--FAIL, package has spelling errors in the changelog

Additionally, a readline compatibility module is included which 
provides a subset of the function of the readline library.

-should be-

Additionally, a readline compatibility module is included, which
provides a subset of the functionality of the readline library.

MUST: The package must be licensed with a Fedora approved license and meet the Licensing Guidelines .
--CHECK


MUST: The License field in the package spec file must match the actual license. [3]
--CHECK

MUST: If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package must be included in %doc.[4]
--CHECK

MUST: The spec file must be written in American English. [5]
--FAIL, see above, small fixes though.

MUST: The spec file for the package MUST be legible. [6]
--CHECK

MUST: The sources used to build the package must match the upstream source, as provided in the spec URL. Reviewers should use md5sum for this task. If no upstream URL can be specified for this package, please see the Source URL Guidelines for how to deal with this.
--CHECK

MUST: The package MUST successfully compile and build into binary rpms on at least one primary architecture. [7]
--CHECK

MUST: If the package does not successfully compile, build or work on an architecture, then those architectures should be listed in the spec in ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in bugzilla, describing the reason that the package does not compile/build/work on that architecture. The bug number MUST be placed in a comment, next to the corresponding ExcludeArch line. [8]
--CHECK

MUST: All build dependencies must be listed in BuildRequires, except for any that are listed in the exceptions section of the Packaging Guidelines ; inclusion of those as BuildRequires is optional. Apply common sense.
--CHECK

MUST: The spec file MUST handle locales properly. This is done by using the %find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.[9]
--CHECK

MUST: Every binary RPM package (or subpackage) which stores shared library files (not just symlinks) in any of the dynamic linker's default paths, must call ldconfig in %post and %postun. [10]
--CHECK

MUST: If the package is designed to be relocatable, the packager must state this fact in the request for review, along with the rationalization for relocation of that specific package. Without this, use of Prefix: /usr is considered a blocker. [11]
--CHECK

MUST: A package must own all directories that it creates. If it does not create a directory that it uses, then it should require a package which does create that directory. [12]
--CHECK

MUST: A Fedora package must not list a file more than once in the spec file's %files listings. [13]
--CHECK

MUST: Permissions on files must be set properly. Executables should be set with executable permissions, for example. Every %files section must include a %defattr(...) line. [14]
--CHECK

MUST: Each package must have a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [15]
--CHECK

MUST: Each package must consistently use macros. [16]
--CHECK

MUST: The package must contain code, or permissable content. [17]
--CHECK

MUST: Large documentation files must go in a -doc subpackage. (The definition of large is left up to the packager's best judgement, but is not restricted to size. Large can refer to either size or quantity). [18]
--CHECK

MUST: If a package includes something as %doc, it must not affect the runtime of the application. To summarize: If it is in %doc, the program must run properly if it is not present. [18]
--CHECK

MUST: Header files must be in a -devel package. [19]
--CHECK

MUST: Static libraries must be in a -static package. [20]
--CHECK

MUST: Packages containing pkgconfig(.pc) files must 'Requires: pkgconfig' (for directory ownership and usability). [21]
--CHECK

MUST: If a package contains library files with a suffix (e.g. libfoo.so.1.1), then library files that end in .so (without suffix) must go in a -devel package. [19]
--CHECK

MUST: In the vast majority of cases, devel packages must require the base package using a fully versioned dependency: Requires: %{name} = %{version}-%{release} [22]
--CHECK

MUST: Packages must NOT contain any .la libtool archives, these must be removed in the spec if they are built.[20]
--CHECK

MUST: Packages containing GUI applications must include a %{name}.desktop file, and that file must be properly installed with desktop-file-install in the %install section. If you feel that your packaged GUI application does not need a .desktop file, you must put a comment in the spec file with your explanation. [23]
--CHECK

MUST: Packages must not own files or directories already owned by other packages. The rule of thumb here is that the first package to be installed should own the files or directories that other packages may rely upon. This means, for example, that no package in Fedora should ever share ownership with any of the files or directories owned by the filesystem or man package. If you feel that you have a good reason to own a file or directory that another package owns, then please present that at package review time. [24]
--CHECK

MUST: At the beginning of %install, each package MUST run rm -rf %{buildroot} (or $RPM_BUILD_ROOT). [25]
--CHECK

MUST: All filenames in rpm packages must be valid UTF-8. [26]
--CHECK




SHOULD Items:
Items marked as SHOULD are things that the package (or reviewer) SHOULD do, but is not required to do.

SHOULD: If the source package does not include license text(s) as a separate file from upstream, the packager SHOULD query upstream to include it. [27]
--CHECK

SHOULD: The description and summary sections in the package spec file should contain translations for supported Non-English languages, if available. [28]
--NONE

SHOULD: The reviewer should test that the package builds in mock. [29]
--CHECK

SHOULD: The package should compile and build into binary rpms on all supported architectures. [30]
--CHECK

SHOULD: The reviewer should test that the package functions as described. A package should not segfault instead of running, for example.
--CHECK

SHOULD: If scriptlets are used, those scriptlets must be sane. This is vague, and left up to the reviewers judgement to determine sanity. [31]
--CHECK

SHOULD: Usually, subpackages other than devel should require the base package using a fully versioned dependency. [22]
--CHECK

SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and this is usually for development purposes, so should be placed in a -devel pkg. A reasonable exception is that the main pkg itself is a devel tool not installed in a user runtime, e.g. gcc or gdb. [21]
--CHECK

SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin, /usr/bin, or /usr/sbin consider requiring the package which provides the file instead of the file itself. [32] 
--CHECK

Resolution: Fail

Todo: Fix up the spec file, mainly small one character changes here and there that will make alot of these issues go away. Once' that's done, i can recheck an updated package and verify the fixes, so we can pass this review.
Comment 2 Jochen Schmitt 2009-07-16 12:03:37 EDT
thank you for your review.

Next Release:

Spec URL: http://www.herr-schmitt.de/pub/ghc-editline/ghc-editline.spec
SRPM URL:
http://www.herr-schmitt.de/pub/ghc-editline/ghc-editline-0.2.1.0-2.fc11.src.rpm
Comment 3 Yaakov Nemoy 2009-07-17 05:44:32 EDT
Ok, running down the list of failures.

It's building in ix86, which is good.

The %description section still contains the minor grammatical issues i pointed out. This isn't a blocker, but please fix it at some point.

[yankee@koan ghc-editline]$ rpmlint -v ghc-editline*0.2.1.0-2*rpm
ghc-editline.src: I: checking
ghc-editline.src: I: checking
ghc-editline-devel.i586: I: checking
ghc-editline-devel.ppc: I: checking
ghc-editline-devel.x86_64: I: checking
ghc-editline-doc.i586: I: checking
ghc-editline-doc.ppc: I: checking
ghc-editline-doc.x86_64: I: checking
ghc-editline-prof.i586: I: checking
ghc-editline-prof.i586: E: devel-dependency ghc-editline-devel
ghc-editline-prof.i586: W: no-documentation
ghc-editline-prof.i586: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/editline-0.2.1.0/libHSeditline-0.2.1.0_p.a
ghc-editline-prof.ppc: I: checking
ghc-editline-prof.ppc: E: devel-dependency ghc-editline-devel
ghc-editline-prof.ppc: W: no-documentation
ghc-editline-prof.ppc: W: devel-file-in-non-devel-package /usr/lib/ghc-6.10.3/editline-0.2.1.0/libHSeditline-0.2.1.0_p.a
ghc-editline-prof.x86_64: I: checking
ghc-editline-prof.x86_64: E: devel-dependency ghc-editline-devel
ghc-editline-prof.x86_64: W: no-documentation
ghc-editline-prof.x86_64: W: devel-file-in-non-devel-package /usr/lib64/ghc-6.10.3/editline-0.2.1.0/libHSeditline-0.2.1.0_p.a
11 packages and 0 specfiles checked; 3 errors, 6 warnings.

Resolution: PASS

Thanks for the submission!
Comment 4 Jochen Schmitt 2009-07-19 15:08:11 EDT
New Package CVS Request
=======================
Package Name: ghc-editline
Short Description: Haskell editline library
Owners: s4504kr
Branches: F-11, F-10
InitialCC:
Comment 5 Kevin Fenzi 2009-07-19 16:53:27 EDT
cvs done.
Comment 6 Yaakov Nemoy 2009-07-20 04:38:59 EDT
Please don't forget to close this bug once you have a package built and pushed to rawhide.
Comment 7 Ville Skyttä 2009-07-21 13:52:33 EDT
Typo in Summary: s/pgk_name/pkg_name/

https://www.redhat.com/archives/fedora-devel-list/2009-July/msg01294.html
New package ghc-editline
        Haskell %{pgk_name} library
Comment 8 Jens Petersen 2009-07-22 20:38:10 EDT
(In reply to comment #7)
> Typo in Summary: s/pgk_name/pkg_name/

Thanks, Jochen fixed that.

https://admin.fedoraproject.org/pkgdb/packages/name/ghc-editline
I added haskell-sig to InitialCC: please remember to do that in future. :)
Comment 9 Jens Petersen 2009-07-22 20:39:14 EDT
Also added missing "Requires: libedit-devel" in devel subpackage.

Note You need to log in before you can comment on or make changes to this bug.